#include "CGame.h"

CGame::CGame()
{quadric=NULL;
 Texture=NULL;
 Target=NULL;
 Player=NULL;

 bBreak=false;
 bActive=false;
}

CGame::~CGame()
{stop();
}

void CGame::collectScore()
{
    bActive=false;
    bGetScore=true;
}

void CGame::start(SOptions *opt)//nach Men jeweils neu belegt oder entsprechent zurckgesetzt
{//GLEistellungen

 glViewport(0,0,opt->iWidth,opt->iHeight);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 gluPerspective(opt->iPerspective*10+30, (GLfloat)opt->iWidth/(GLfloat)opt->iHeight, 0.1, 700.0);
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity();
 glClearColor(0,0,0,1);
 
 quadric = gluNewQuadric();
 gluQuadricOrientation(quadric,GLU_INSIDE);
 gluQuadricTexture(quadric,GL_TRUE);
 gluQuadricNormals(quadric,GLU_SMOOTH);

 glEnable(GL_TEXTURE_2D);
 
 glAlphaFunc(GL_GREATER, 0.1);
 glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 glEnable(GL_BLEND);
 
 if(opt->iBkgnd==2)
 {  float L0Diffuse[] = {0.3,-0.3,-0.3, 1.0};
    float L0Ambient[] = {0.0, 0.0, 0.0, 1.0};
    glLightfv(GL_LIGHT0, GL_AMBIENT, L0Ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, L0Diffuse);
 }
 else
 {  float L0Diffuse[] = {1.0, 1.0, 1.0, 1.0};
    float L0Ambient[] = {0.3, 0.3, 0.3, 1.0};
    glLightfv(GL_LIGHT0, GL_AMBIENT, L0Ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, L0Diffuse);
 }

 glLightf(GL_LIGHT0, GL_QUADRATIC_ATTENUATION, pow(125.0/(opt->iSpaceX*opt->iSpaceY*opt->iSpaceZ),0.6)*0.0001);
 glLightf(GL_LIGHT0, GL_CONSTANT_ATTENUATION, 0);
 glLightf(GL_LIGHT0, GL_LINEAR_ATTENUATION, 0);
    
 glEnable(GL_LIGHTING);

 glEnable(GL_COLOR_MATERIAL);
 glShadeModel(GL_SMOOTH);
 glClearDepth(1.0);
 glEnable(GL_DEPTH_TEST);
 glDepthFunc(GL_LEQUAL);
 glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);  


  //PNGs
 #define PNGZahl 9
 Texture = new GLuint[PNGZahl];
 const char *pfad[]={"Data/Target.png","Data/Snake1.png","Data/Bkgnd1.png","Data/Bkgnd2.png","Data/ready.png","Data/go.png",
 "Data/break.png","Data/Bkgnd3.png","Data/Snake2.png"};
 bool linear[]=     {true             ,            true,             true,             true,           true ,       true  ,
        true     ,      true       ,      true       };
 if (!LoadPNGs(PNGZahl, pfad, linear, Texture)) fprintf(stderr,"Fehler... beim laden der Texturen");

 
 //Variablen (re)setten 
 Options=opt;
 iTime=0;
 bBreak=false;
 bGameOver=false;
 fStep=Options->iVelocity/2.0;
 iPlayerGO=0;
 bGetScore=false;
 
 
 Player=new CPlayer*[Options->iPlayerCount];
 for(int i=0;i<Options->iPlayerCount;++i) Player[i]=new CPlayer(this);
 for(int i=0;i<Options->iPlayerCount;++i) Player[i]->start(i);
 
 Target = new CTarget(this);
 Target->Init(opt->iTargetSize-1);

  
 if(Options->bSound)
 {
     //initSound
 }
 

 bBeginning=true;
 bActive=true;
}

void CGame::stop()
{
    for (int i=0;i<Options->iPlayerCount;++i) if (Player[i]) {delete Player[i]; Player[i]=NULL;}
    if (Player) delete[] Player;
    Player=NULL;
    if (Target) delete Target;
    Target=NULL;
    if (Texture) delete[] Texture;
    Texture=NULL;
    bActive=false;
}

void CGame::calculate()
{if (!bActive) return;
 if (bBreak) return;
 if (bGameOver) {collectScore(); return;}
 if (bBeginning) return;
 
 if(Player) for (int i=0;i<Options->iPlayerCount;++i) if (Player[i]) Player[i]->calculate();
}

void CGame::draw()
{if (!bActive) return;
 if (!Player) return;
 
 glClear(GL_COLOR_BUFFER_BIT);

 if (Options->bSplit)
 {  glViewport(Options->iWidth/2, 0, Options->iWidth/2, Options->iHeight);
    glMatrixMode (GL_PROJECTION); // whle die Projektions-Matrix aus  
    glLoadIdentity (); // Resette die Projektions-Matrix  
    gluPerspective(Options->iPerspective*10+30, (GLfloat)Options->iWidth/2/(GLfloat)Options->iHeight, 0.1, 10000.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glClear(GL_DEPTH_BUFFER_BIT);
    Player[0]->draw();
    if (!bActive) return;
    
    glViewport(0, 0, Options->iWidth/2, Options->iHeight);
    glMatrixMode (GL_PROJECTION); // whle die Projektions-Matrix aus  
    glLoadIdentity (); // Resette die Projektions-Matrix  
    gluPerspective(Options->iPerspective*10+30, (GLfloat)Options->iWidth/2/(GLfloat)Options->iHeight, 0.1, 10000.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glClear(GL_DEPTH_BUFFER_BIT);
    Player[1]->draw();
    if (!bActive) return;
 }
 else 
 {  glClear(GL_DEPTH_BUFFER_BIT);
    Player[Options->iThisPlayerNr]->draw();
    if (!bActive) return;
   
 }
}

void CGame::play()
{
    //Sound
}

bool CGame::LoadPNGs(const int anzahl, const char* pfad[], bool linear[], GLuint *textur)
{glGenTextures(anzahl, textur);
 uchar *image_data = NULL;
 int pngw,pngh;
 for (int i=0; i<anzahl; ++i)
 {  image_data = NULL;
    QImage image(pfad[i]);
    image = image.mirrored(false,true);
    int k = image.numBytes();
    image_data = image.bits();
    int n = k/4;
    uchar h;
    for (int j=0;j<n;++j) //tausche rot und blau
    {
        h = image_data[j*4+0];
        image_data[j*4+0] = image_data[j*4+2];
        image_data[j*4+2] = h;
    }
    pngw = image.width();
    pngh = image.height();
    if(!image_data)
    {
        FILE *f = fopen("error.txt","a");
        fprintf(f,"Fehler beim Lesen einer Datei: %s\n", pfad[i]);
        fclose(f);
        return false;
    }
    glBindTexture(GL_TEXTURE_2D, textur[i]);
    glTexImage2D(GL_TEXTURE_2D, 0, 4, pngw, pngh, 0, GL_RGBA, GL_UNSIGNED_BYTE, image_data);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    if (linear[i])
    {  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
       glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    }
    else
    {  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
       glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    }
 }
 return true;
}

void CGame::getScore(SScoreData *s)
{
    if (Options->bSplit)
    {
        s[0] = *(Player[0]->ScoreData);
        s[1] = *(Player[1]->ScoreData);
    }
    else
    {
        s[0] = *(Player[0]->ScoreData);
    }
    for (int i=0;i<Options->iPlayerCount;++i) Player[i]->stop();
    stop();
}
