#ifndef CPLAYER_H
#define CPLAYER_H

#include <QtOpenGL>
#include "globalStructs.h"
#include "csnake.h"
#include "cgame.h"

class CPlayer
{public:
   CPlayer(CGame *);
   ~CPlayer();
   void start(int);
   void stop();
   void draw();
   void calculate();
   void input(int);
   void GameOver(int);
   void RotateMatrix(float* in, float angle, SVector3f r);
   void Mult4x4Matrix(float* M,float* A,float* B);
   void RotateVec(SVector3f* vec, SVector3f rot, float angle);
   float getAngle(float x,float y);
   void drawCube2(float x, float y, float z, float fPicture, bool NormalOut, int q);

   CSnake *Snake;
   CGame *Game;

   SScoreData* ScoreData;
   int NR;
   bool bActive;
   SVector3f vTrans,vTransNext;
   int iTime;
   float RotMatrix[16];
   SVector3i vPos;
   SVector3f VecX,VecY,VecZ;
   short MomAction;
   float ZCorrection;
   float RotAngle;
   float BaseRotMatrix[16];
   SVector3f NextVecZ;
   bool bGameOver;
};



#endif // CPLAYER_H
