#include "csnake.h"

CSnake::CSnake(CGame *_Game)
{bActive=false;
 Game =_Game;
}





void CSnake::Init(int _NR, SVector3i vStartPos, int _iBody, int _iElementsLeft)
{iBody=_iBody;
 iCollected=0;
 iElementsLeft=_iElementsLeft;
 firstElement=vStartPos;
 bActive=true;
 NR=_NR;
}





CSnake::~CSnake()
{
}






void CSnake::draw(bool drawHead,int iPlayerNR)
{if (!bActive) return;

 glLoadIdentity();

 glMultMatrixf(Game->Player[iPlayerNR]->RotMatrix);
 glTranslatef(Game->Player[iPlayerNR]->vTrans.x,Game->Player[iPlayerNR]->vTrans.y,Game->Player[iPlayerNR]->vTrans.z);

 switch (iBody)
 {  case 0: glBindTexture(GL_TEXTURE_2D,Game->Texture[1]); glColor3ub(0,0,255); break;
    case 1: glBindTexture(GL_TEXTURE_2D,Game->Texture[8]); glColor3ub(20,100,0); break;
    default: /*qDebug("Snake: Unknown iBody: %i\n",iBody);//*/fprintf(stderr,"Snake: Unknown iBody: %i\n",iBody);
 }
 if (Game->Options->iBkgnd==2) glColor3ub(255,255,255);

 if (Game->Options->iBkgnd!=2) for (int i=0;i<(int)Pos1.size();++i) drawConnected(Pos1[i],Pos2[i]);
 else for (int i=0;i<(int)nextElement.size();++i)
 {  glPushMatrix();
    SVector3i s = getPos(i);
    glTranslatef(-s.x*20.0-10.0,-s.y*20.0-10.0,-s.z*20.0-10.0);
    drawCube(10,10,10,0.1,true);
    glPopMatrix();
}

 if(drawHead)
 {  glLoadIdentity();
    glMultMatrixf(Game->Player[iPlayerNR]->RotMatrix);
    glTranslatef(Game->Player[iPlayerNR]->vTrans.x,Game->Player[iPlayerNR]->vTrans.y,Game->Player[iPlayerNR]->vTrans.z);
    glTranslatef(-10-firstElement.x*20,-10-firstElement.y*20,-10-firstElement.z*20);
    drawPyramide(10,Game->Player[NR]->VecX,Game->Player[NR]->VecY,Game->Player[NR]->VecZ);
 }
}



void CSnake::RotateVec(SVector3f* vec, SVector3f rot, float angle)
{float abs,richt;
 angle=angle/180*M_PI;
 bool b=false;
 if ((fabs(rot.x)==1)&&(rot.y==0)&&(rot.z==0))
 {  if (rot.x==-1) angle=-angle;
    abs=sqrt(vec->y*vec->y+vec->z*vec->z);
    richt=getAngle(vec->y,vec->z);
    vec->y=cos(richt+angle)*abs;
    vec->z=sin(richt+angle)*abs;
    b=true;
 }
 else if ((fabs(rot.y)==1)&&(rot.x==0)&&(rot.z==0))
 {  if (rot.y==-1) angle=-angle;
    abs=sqrt(vec->x*vec->x+vec->z*vec->z);
    richt=getAngle(vec->z,vec->x);
    vec->z=cos(richt+angle)*abs;
    vec->x=sin(richt+angle)*abs;
    b=true;
 }
 else if ((fabs(rot.z)==1)&&(rot.x==0)&&(rot.y==0))
 {  if (rot.z==-1) angle=-angle;
    abs=sqrt(vec->y*vec->y+vec->x*vec->x);
    richt=getAngle(vec->x,vec->y);
    vec->x=cos(richt+angle)*abs;
    vec->y=sin(richt+angle)*abs;
    b=true;
 }
 vec->x=round(vec->x);
 vec->y=round(vec->y);
 vec->z=round(vec->z);
 if(!b) fprintf(stderr,"Problem: RotateVec hat nix gemacht\n%e,%e,%e\n%e,%e,%e\n%e\n",vec->x,vec->y,vec->z,rot.x,rot.y,rot.z,angle);
}







void CSnake::move(SVector3i vNewHeadPos, bool bLeaveLast)
{if (bLeaveLast)
 {  ++iElementsLeft;
    ++iCollected;
 }
 if (iElementsLeft==0)
 {  for (int i=(int)nextElement.size()-1;i>0;--i) nextElement[i]=nextElement[i-1];
    if((int)nextElement.size()>0)
    {  if(vNewHeadPos.x-firstElement.x==-1) nextElement[0]=1;
       if(vNewHeadPos.x-firstElement.x==+1) nextElement[0]=2;
       if(vNewHeadPos.y-firstElement.y==-1) nextElement[0]=3;
       if(vNewHeadPos.y-firstElement.y==+1) nextElement[0]=4;
       if(vNewHeadPos.z-firstElement.z==-1) nextElement[0]=5;
       if(vNewHeadPos.z-firstElement.z==+1) nextElement[0]=6;
    }
    firstElement=vNewHeadPos;
 }
 else
 {  if ((int)nextElement.size()>0) nextElement.push_back(nextElement[(int)nextElement.size()-1]);
    else nextElement.push_back(0); // wird in 2 Zeilen gessetet
    for (int i=(int)nextElement.size()-2;i>0;--i) nextElement[i]=nextElement[i-1];
    if(vNewHeadPos.x-firstElement.x==-1) nextElement[0]=1;
    if(vNewHeadPos.x-firstElement.x==+1) nextElement[0]=2;
    if(vNewHeadPos.y-firstElement.y==-1) nextElement[0]=3;
    if(vNewHeadPos.y-firstElement.y==+1) nextElement[0]=4;
    if(vNewHeadPos.z-firstElement.z==-1) nextElement[0]=5;
    if(vNewHeadPos.z-firstElement.z==+1) nextElement[0]=6;
    firstElement=vNewHeadPos;
    --iElementsLeft;
  }
  searchConnected();
}








bool CSnake::InElement(SVector3i vTest, bool checkHead)
{int PosX=firstElement.x;
 int PosY=firstElement.y;
 int PosZ=firstElement.z;
 if(checkHead)if ((PosX==vTest.x)&&(PosY==vTest.y)&&(PosZ==vTest.z)) return true;
 for (int i=0;i<(int)nextElement.size();++i)
 {  switch (nextElement[i])
    {  case 1: ++PosX; break;
       case 2: --PosX; break;
       case 3: ++PosY; break;
       case 4: --PosY; break;
       case 5: ++PosZ; break;
       case 6: --PosZ; break;
       default: fprintf(stderr,"unknown nextElement direction: %i\n",nextElement[i]);
    }
    if ((PosX==vTest.x)&&(PosY==vTest.y)&&(PosZ==vTest.z)) return true;
 }
 return false;
}








void CSnake::searchConnected()
{Pos1.resize(0);
 Pos2.resize(0);
 int i;
 for (int j=0;j<(int)nextElement.size();)
 {  Pos1.push_back(getPos(j));
    for (i=j+1;i<(int)nextElement.size();++i) if(nextElement[i]!=nextElement[i-1]) break;
    Pos2.push_back(getPos(i-1));
    j=i;
 }
}



void CSnake::drawConnected(SVector3i Pos1, SVector3i Pos2)
{    SVector3f p1, p2, pd;
     if ((Pos1.x<Pos2.x)||(Pos1.y<Pos2.y)||(Pos1.z<Pos2.z))
     {  p1.x=-Pos1.x*20-10+10;
        p1.y=-Pos1.y*20-10+10;
        p1.z=-Pos1.z*20-10+10;
        p2.x=-Pos2.x*20-10-10;
        p2.y=-Pos2.y*20-10-10;
        p2.z=-Pos2.z*20-10-10;
     }
     else
     {  p2.x=-Pos1.x*20-10-10;
        p2.y=-Pos1.y*20-10-10;
        p2.z=-Pos1.z*20-10-10;
        p1.x=-Pos2.x*20-10+10;
        p1.y=-Pos2.y*20-10+10;
        p1.z=-Pos2.z*20-10+10;
     }
     pd.x=abs(Pos2.x-Pos1.x)+1;
     pd.y=abs(Pos2.y-Pos1.y)+1;
     pd.z=abs(Pos2.z-Pos1.z)+1;

     glBegin(GL_QUADS); // fange an Quadrate zu zeichnen
     // obere Seite
     glNormal3f(0.0,-1,0.0);
     glTexCoord2f(0.0, pd.z);  glVertex3f(p1.x,p2.y,p1.z); // oben links der Textur und des Quadrates
     glTexCoord2f(0.0, 0.0);   glVertex3f(p1.x,p2.y,p2.z); // unten links der Textur und des Quadrates
     glTexCoord2f(pd.x, 0.0);  glVertex3f(p2.x,p2.y,p2.z); // unten rechts der Textur und des Quadrates
     glTexCoord2f(pd.x, pd.z); glVertex3f(p2.x,p2.y,p1.z); // oben rechts der Textur und des Quadrates
     // untere Seite
     glNormal3f(0.0,1,0.0);
     glTexCoord2f(pd.x, pd.z); glVertex3f(p1.x,p1.y,p1.z); // oben rechts der Textur und des Quadrates
     glTexCoord2f(0.0, pd.z);  glVertex3f(p2.x,p1.y,p1.z); // oben links der Textur und des Quadrates
     glTexCoord2f(0.0, 0.0);   glVertex3f(p2.x,p1.y,p2.z); // unten links der Textur und des Quadrates
     glTexCoord2f(pd.x, 0.0);  glVertex3f(p1.x,p1.y,p2.z); // unten rechts der Textur und des Quadrates
     // vordere Seite
     glNormal3f(0.0,0.0,-1);
     glTexCoord2f(0.0, 0.0);   glVertex3f(p1.x,p1.y,p2.z); // unten links der Textur und des Quadrates
     glTexCoord2f(pd.x, 0.0);  glVertex3f(p2.x,p1.y,p2.z); // unten rechts der Textur und des Quadrates
     glTexCoord2f(pd.x, pd.y); glVertex3f(p2.x,p2.y,p2.z); // oben rechts der Textur und des Quadrates
     glTexCoord2f(0.0, pd.y);  glVertex3f(p1.x,p2.y,p2.z); // oben links der Textur und des Quadrates
     // hintere Seite
     glNormal3f(0.0,0.0,1);
     glTexCoord2f(pd.x, 0.0);  glVertex3f(p1.x,p1.y,p1.z); // unten rechts der Textur und des Quadrates
     glTexCoord2f(pd.x, pd.y); glVertex3f(p1.x,p2.y,p1.z); // oben rechts der Textur und des Quadrates
     glTexCoord2f(0.0, pd.y);  glVertex3f(p2.x,p2.y,p1.z); // oben links der Textur und des Quadrates
     glTexCoord2f(0.0, 0.0);   glVertex3f(p2.x,p1.y,p1.z); // unten links der Textur und des Quadrates
     // rechte Seite
     glNormal3f(-1,0.0,0.0);
     glTexCoord2f(pd.z, 0.0);  glVertex3f(p2.x,p1.y,p1.z); // unten rechts der Textur und des Quadrates
     glTexCoord2f(pd.z, pd.y); glVertex3f(p2.x,p2.y,p1.z); // oben rechts der Textur und des Quadrates
     glTexCoord2f(0.0, pd.y);  glVertex3f(p2.x,p2.y,p2.z); // oben links der Textur und des Quadrates
     glTexCoord2f(0.0, 0.0);   glVertex3f(p2.x,p1.y,p2.z); // unten links der Textur und des Quadrates
     // linke Seite
     glNormal3f(1,0.0,0.0);
     glTexCoord2f(0.0, 0.0);   glVertex3f(p1.x,p1.y,p1.z); // unten links der Textur und des Quadrates
     glTexCoord2f(pd.z, 0.0);  glVertex3f(p1.x,p1.y,p2.z); // unten rechts der Textur und des Quadrates
     glTexCoord2f(pd.z, pd.y); glVertex3f(p1.x,p2.y,p2.z); // oben rechts der Textur und des Quadrates
     glTexCoord2f(0.0, pd.y);  glVertex3f(p1.x,p2.y,p1.z); // oben links der Textur und des Quadrates
   glEnd();
}




SVector3i CSnake::getPos(int n)
{SVector3i v = firstElement;
 for (int i=0;i<=n;++i)
 {  switch (nextElement[i])
    {  case 1: ++v.x; break;
       case 2: --v.x; break;
       case 3: ++v.y; break;
       case 4: --v.y; break;
       case 5: ++v.z; break;
       case 6: --v.z; break;
       default: fprintf(stderr,"unknown nextElement direction: %i\n",nextElement[i]);
    }
 }
 return v;
}


void CSnake::drawPyramide(int s,SVector3f VecX,SVector3f VecY,SVector3f VecZ)
{glBegin(GL_TRIANGLE_FAN);
   glTexCoord2f(0,0); glVertex3f(-VecZ.x*s,-VecZ.y*s,-VecZ.z*s);
   glTexCoord2f(0,1); glVertex3f(VecZ.x*s+VecX.x*s+VecY.x*s,VecZ.y*s+VecX.y*s+VecY.y*s,VecZ.z*s+VecX.z*s+VecY.z*s);
   glTexCoord2f(1,0); glVertex3f(VecZ.x*s-VecX.x*s+VecY.x*s,VecZ.y*s-VecX.y*s+VecY.y*s,VecZ.z*s-VecX.z*s+VecY.z*s);
   glTexCoord2f(0,1); glVertex3f(VecZ.x*s-VecX.x*s-VecY.x*s,VecZ.y*s-VecX.y*s-VecY.y*s,VecZ.z*s-VecX.z*s-VecY.z*s);
   glTexCoord2f(1,0); glVertex3f(VecZ.x*s+VecX.x*s-VecY.x*s,VecZ.y*s+VecX.y*s-VecY.y*s,VecZ.z*s+VecX.z*s-VecY.z*s);
   glTexCoord2f(0,1); glVertex3f(VecZ.x*s+VecX.x*s+VecY.x*s,VecZ.y*s+VecX.y*s+VecY.y*s,VecZ.z*s+VecX.z*s+VecY.z*s);
 glEnd();
 glBegin(GL_QUADS);
   glTexCoord2f(1,1); glVertex3f(VecZ.x*s+VecX.x*s+VecY.x*s,VecZ.y*s+VecX.y*s+VecY.y*s,VecZ.z*s+VecX.z*s+VecY.z*s);
   glTexCoord2f(0,1); glVertex3f(VecZ.x*s-VecX.x*s+VecY.x*s,VecZ.y*s-VecX.y*s+VecY.y*s,VecZ.z*s-VecX.z*s+VecY.z*s);
   glTexCoord2f(0,0); glVertex3f(VecZ.x*s-VecX.x*s-VecY.x*s,VecZ.y*s-VecX.y*s-VecY.y*s,VecZ.z*s-VecX.z*s-VecY.z*s);
   glTexCoord2f(0,1); glVertex3f(VecZ.x*s+VecX.x*s-VecY.x*s,VecZ.y*s+VecX.y*s-VecY.y*s,VecZ.z*s+VecX.z*s-VecY.z*s);
 glEnd();
}


float CSnake::getAngle(float x,float y)
{float w;
 if (x==0) w=M_PI/2.0;
 else w=atan(fabs(y/x));
 if (x<0) w=M_PI-w;
 if (y<0) w=2.0*M_PI-w;
 return w;
}


void CSnake::drawCube(float x, float y, float z, float fPicture, bool NormalOut)
{ int n=1;
  if (NormalOut) n=-1;
     glBegin(GL_QUADS); // fange an Quadrate zu zeichnen
     // obere Seite
     glNormal3f(0.0,-1*n,0.0);
     glTexCoord2f(0.0, fPicture*z); glVertex3f(-x, y, -z); // oben links der Textur und des Quadrates
     glTexCoord2f(0.0, 0.0); glVertex3f(-x, y, z); // unten links der Textur und des Quadrates
     glTexCoord2f(fPicture*x, 0.0); glVertex3f( x, y, z); // unten rechts der Textur und des Quadrates
     glTexCoord2f(fPicture*x, fPicture*z); glVertex3f( x, y, -z); // oben rechts der Textur und des Quadrates
     // untere Seite
     glNormal3f(0.0,n,0.0);
     glTexCoord2f(fPicture*x, fPicture*z); glVertex3f(-x,-y, -z); // oben rechts der Textur und des Quadrates
     glTexCoord2f(0.0, fPicture*z); glVertex3f( x,-y, -z); // oben links der Textur und des Quadrates
     glTexCoord2f(0.0, 0.0); glVertex3f( x,-y, z); // unten links der Textur und des Quadrates
     glTexCoord2f(fPicture*x, 0.0); glVertex3f(-x,-y, z); // unten rechts der Textur und des Quadrates
     // vordere Seite
     glNormal3f(0.0,0.0,-1*n);
     glTexCoord2f(0.0, 0.0); glVertex3f(-x,-y, z); // unten links der Textur und des Quadrates
     glTexCoord2f(fPicture*x, 0.0); glVertex3f( x,-y, z); // unten rechts der Textur und des Quadrates
     glTexCoord2f(fPicture*x, fPicture*y); glVertex3f( x, y, z); // oben rechts der Textur und des Quadrates
     glTexCoord2f(0.0, fPicture*y); glVertex3f(-x, y, z); // oben links der Textur und des Quadrates
     // hintere Seite
     glNormal3f(0.0,0.0,n);
     glTexCoord2f(fPicture*x, 0.0); glVertex3f(-x,-y, -z); // unten rechts der Textur und des Quadrates
     glTexCoord2f(fPicture*x, fPicture*y); glVertex3f(-x, y, -z); // oben rechts der Textur und des Quadrates
     glTexCoord2f(0.0, fPicture*y); glVertex3f( x, y, -z); // oben links der Textur und des Quadrates
     glTexCoord2f(0.0, 0.0); glVertex3f( x,-y, -z); // unten links der Textur und des Quadrates
     // rechte Seite
     glNormal3f(-1*n,0.0,0.0);
     glTexCoord2f(fPicture*z, 0.0); glVertex3f( x,-y, -z); // unten rechts der Textur und des Quadrates
     glTexCoord2f(fPicture*z, fPicture*y); glVertex3f( x, y, -z); // oben rechts der Textur und des Quadrates
     glTexCoord2f(0.0, fPicture*y); glVertex3f( x, y, z); // oben links der Textur und des Quadrates
     glTexCoord2f(0.0, 0.0); glVertex3f( x,-y, z); // unten links der Textur und des Quadrates
     // linke Seite
     glNormal3f(n,0.0,0.0);
     glTexCoord2f(0.0, 0.0); glVertex3f(-x,-y, -z); // unten links der Textur und des Quadrates
     glTexCoord2f(fPicture*z, 0.0); glVertex3f(-x,-y, z); // unten rechts der Textur und des Quadrates
     glTexCoord2f(fPicture*z, fPicture*y); glVertex3f(-x, y, z); // oben rechts der Textur und des Quadrates
     glTexCoord2f(0.0, fPicture*y); glVertex3f(-x, y, -z); // oben links der Textur und des Quadrates
   glEnd();
}
