#include "ctarget.h"

CTarget::CTarget(CGame *_Game)
{
    bActive=false;
    Game = _Game;
}

void CTarget::Init(int _size)
{size=_size;
 bOld=false;

 CreateNew();
 bActive=true;
 iRot=0;
}

CTarget::~CTarget()
{
}

void CTarget::setLightPos(int PlayerNR)
{glLoadIdentity();

 glMultMatrixf(Game->Player[PlayerNR]->RotMatrix);
 glTranslatef(Game->Player[PlayerNR]->vTrans.x,Game->Player[PlayerNR]->vTrans.y,Game->Player[PlayerNR]->vTrans.z);
 glTranslatef(-vPos.x*20.0-10.0,-vPos.y*20.0-10.0,-vPos.z*20.0-10.0);

 float L0Pos[]={0.0,0.0,0.0,1.0};
 glLightfv(GL_LIGHT0, GL_POSITION, L0Pos);
}

void CTarget::draw(int PlayerNR)
{if (!bActive) return;

 glLoadIdentity();
 //glDisable(GL_DEPTH_TEST);

 glMultMatrixf(Game->Player[PlayerNR]->RotMatrix);
 glTranslatef(Game->Player[PlayerNR]->vTrans.x,Game->Player[PlayerNR]->vTrans.y,Game->Player[PlayerNR]->vTrans.z);
 if (bOld) glPushMatrix();
 glTranslatef(-vPos.x*20.0-10.0,-vPos.y*20.0-10.0,-vPos.z*20.0-10.0);

 glBindTexture(GL_TEXTURE_2D,Game->Texture[0]);
 glColor4ub(255,0,0,200);

 glRotatef(iRot,1,1,1);
 //drawSphere(9+20*size,32,false);
 gluSphere(Game->quadric,9+20*size,64,32);

 if (bOld)
 {  glPopMatrix();
    glDisable(GL_DEPTH_TEST);
    if (!Game->bBreak) ++iTime;
    glTranslatef(-vPosOld.x*20.0-10.0,-vPosOld.y*20.0-10.0,-vPosOld.z*20.0-10.0);
    glColor4ub(255,iTime*10,iTime*10,200-iTime*8);
    glRotatef(iRot,1,1,1);
    gluSphere(Game->quadric,9+20*size+iTime*2.0*Game->fStep,64,32);
    if (iTime>=25) bOld=false;
    glEnable(GL_DEPTH_TEST);
 }

 ++iRot;
 //glEnable(GL_DEPTH_TEST);

}

bool CTarget::angekommen(SVector3i vTestPos)
{//uere Ecken bei size 2 und 3 nicht im Target

 float d = sqrt((vTestPos.x-vPos.x)*(vTestPos.x-vPos.x)+
                (vTestPos.y-vPos.y)*(vTestPos.y-vPos.y)+
                (vTestPos.z-vPos.z)*(vTestPos.z-vPos.z));
 d*=20.0;
 if (d<9.5+20.0*size) return true;
 return false;
}

void CTarget::CreateNew()
{vPosOld=vPos;
 bOld=true;
 iTime=0;
 int i=0;
 bool b=true;
 do
 {  vPos.x=(rand()%(Game->Options->iSpaceX*2-size*2))-Game->Options->iSpaceX+size;
    vPos.y=(rand()%(Game->Options->iSpaceY*2-size*2))-Game->Options->iSpaceY+size;
    vPos.z=(rand()%(Game->Options->iSpaceZ*2-size*2))-Game->Options->iSpaceZ+size;
    ++i;
    if (i>10000) {fprintf(stderr,"GameOver cause: Couldn't find adequate position for the Target!\n"); Game->Player[0]->GameOver(2); return;}
    b=false;
    for (int i=0;i<Game->Options->iPlayerCount;++i) if(Game->Player[i]->Snake->InElement(vPos,true)) b=true;
    if ((vPos.x==vPosOld.x)&&(vPos.y==vPosOld.y)&&(vPos.z==vPosOld.z)) b=true;
 } while (b);
}
