#include "highscore.h"
#include "ui_highscore.h"

Highscore::Highscore(SScoreData *_top10, QWidget *parent) :
    QWidget(parent),
    m_ui(new Ui::Highscore)
{
    nr=-1;
    top10=_top10;
    m_ui->setupUi(this);
    connect(m_ui->ok,SIGNAL(clicked()),this,SLOT(back()));
    fillTable();
    m_ui->name->hide();
    m_ui->lName->hide();
}

Highscore::Highscore(SScoreData *_top10, SScoreData newScore, QWidget *parent) :
    QWidget(parent),
    m_ui(new Ui::Highscore)
{
    top10=_top10;
    m_ui->setupUi(this);
    connect(m_ui->ok,SIGNAL(clicked()),this,SLOT(nameAndBack()));
    connect(m_ui->name,SIGNAL(returnPressed()),this,SLOT(enteredName()));
    nr = insertScore(newScore);
    if (nr<10)
    {
        m_ui->table->setCurrentCell(nr,1);
    }
    else
    {
        m_ui->table->setItem(10,0,new QTableWidgetItem(tr("u r 2 lame for the top10")));
        m_ui->table->setItem(10,1,new QTableWidgetItem(QString::number(newScore.iScore)));
        m_ui->table->setCurrentCell(10,1);
        m_ui->name->hide();
        m_ui->lName->hide();
    }

    fillTable();
}

Highscore::~Highscore()
{
    delete m_ui;
}

void Highscore::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void Highscore::back()
{
    ok();
}

void Highscore::nameAndBack()
{
    if ((nr>=0)||(nr<10))
    {
        QString *str = new QString(m_ui->name->text());
        if (str->isEmpty()) *str = "<unknown>";
        sprintf(top10[nr].cName,"%s",(const char *)str->toAscii());
        delete str;
    }
    ok();
}

void Highscore::enteredName()
{
    if(m_ui->name->text().isEmpty()) return;
    if ((nr>=0)||(nr<10))
    {
        QString *str = new QString(m_ui->name->text());
        sprintf(top10[nr].cName,"%s",(const char *)str->toAscii());
        delete str;
    }
    fillTable();
    m_ui->name->hide();
    m_ui->lName->hide();
    disconnect(m_ui->ok,SIGNAL(clicked()),this,SLOT(nameAndBack()));
    connect(m_ui->ok,SIGNAL(clicked()),this,SLOT(back()));
}

void Highscore::fillTable()
{
    m_ui->table->setColumnWidth(0,200);
    m_ui->table->setColumnWidth(1,80);
    m_ui->table->setColumnWidth(2,80);
    m_ui->table->setColumnWidth(3,80);
    m_ui->table->setColumnWidth(4,80);
    m_ui->table->setColumnWidth(5,80);
    m_ui->table->setColumnWidth(6,80);
    for (int i=0;i<10;++i)
    {
        if (top10[i].iScore==0) break;
        m_ui->table->setItem(i,0,new QTableWidgetItem(tr(top10[i].cName)));
        m_ui->table->setItem(i,1,new QTableWidgetItem(QString::number(top10[i].iScore)));
        m_ui->table->setItem(i,2,new QTableWidgetItem(QString::number(top10[i].iVelocity)));
        m_ui->table->setItem(i,3,new QTableWidgetItem(QString::number(top10[i].iCollected)));
        if (top10[i].iStartLength==-2) m_ui->table->setItem(i,4,new QTableWidgetItem(tr("Survival")));
        else m_ui->table->setItem(i,4,new QTableWidgetItem(QString::number(top10[i].iStartLength)));
        m_ui->table->setItem(i,5,new QTableWidgetItem(QString::number(top10[i].iSpace)));
        m_ui->table->setItem(i,6,new QTableWidgetItem(QString::number(top10[i].iTargetSize)));
    }
}

int Highscore::insertScore(SScoreData scr)
{
    int i;
    for (i=0;i<10;++i) if (scr.iScore > top10[i].iScore) break;
    if (i<10)
    {
        for (int j=9;j>i;--j) top10[j]=top10[j-1];
        top10[i] = scr;
        top10[i].cName[0]='\0';
    }
    return i;
}
