#include "mainm.h"
#include "ui_mainm.h"

MainM::MainM(QWidget *parent) :
    QWidget(parent),
    m_ui(new Ui::MainM)
{
    m_ui->setupUi(this);

    connect(m_ui->single,SIGNAL(clicked()),this,SLOT(spSlot()));
    connect(m_ui->multi,SIGNAL(clicked()),this,SLOT(mpSlot()));
    connect(m_ui->help,SIGNAL(clicked()),this,SLOT(helpSlot()));
    connect(m_ui->score,SIGNAL(clicked()),this,SLOT(scoreSlot()));
    connect(m_ui->close,SIGNAL(clicked()),this,SLOT(closeSlot()));
}

MainM::~MainM()
{
    delete m_ui;
}

void MainM::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void MainM::spSlot()
{
    spSignal();
}

void MainM::mpSlot()
{
    mpSignal();
}

void MainM::helpSlot()
{
    helpSignal();
}

void MainM::scoreSlot()
{
    scoreSignal();
}

void MainM::closeSlot()
{
    closeSignal();
}

