#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include <QRect>
#include "openglwidget.h"
#include "mainm.h"
#include "singleopts.h"
#include "splitopts.h"
#include "globalStructs.h"
#include "highscore.h"
#include "splitscore.h"
#include "help.h"

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QRect screenRect, QWidget *parent = 0);
    ~MainWindow();
    QRect screenRect;

private:
    SOptions opts;
    SScoreData top10[10];
    void writeScore();
    void readScore();
    void readOpts();
    void writeOpts();
    SScoreData score[2];

public slots:
    void openMainMenu();
    void openSingleOpt();
    void openMultiMenu();
    void openHelp();
    void openScore();
    void play(SOptions);
    void enterScore(SScoreData);
    void newScore();
    void receiveScore(SScoreData *s);

};

#endif // MAINWINDOW_H
