#include "openglwidget.h"

OpenGLWidget::OpenGLWidget(SOptions *opt, QWidget *parent)
     : QGLWidget(parent)
{
    setFocusPolicy(Qt::WheelFocus);
    format().setDoubleBuffer(true);
    setAutoBufferSwap(true);
    timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(calledByTimer()));
    timer->start(20);
    setFocus(Qt::ActiveWindowFocusReason);
    opts = *opt;

    makeCurrent();
    game = new CGame();
    game->start(&opts);
}

OpenGLWidget::~OpenGLWidget()
{
    makeCurrent();
}

void OpenGLWidget::paintGL()
{
    game->draw();
}

void OpenGLWidget::keyPressEvent(QKeyEvent *event)
{
    event->accept();
    switch(event->key())
    {
        case Qt::Key_Escape: cancel(); return;
        case Qt::Key_Space: game->bBreak=!game->bBreak; break;
        case Qt::Key_Up: if(game->Player[opts.iThisPlayerNr]) game->Player[opts.iThisPlayerNr]->input(1); break;
        case Qt::Key_Down: if(game->Player[opts.iThisPlayerNr]) game->Player[opts.iThisPlayerNr]->input(2); break;
        case Qt::Key_Left: if(game->Player[opts.iThisPlayerNr]) game->Player[opts.iThisPlayerNr]->input(3); break;
        case Qt::Key_Right: if(game->Player[opts.iThisPlayerNr]) game->Player[opts.iThisPlayerNr]->input(4); break;
        case Qt::Key_W: if((game->Player[1])&&(opts.bSplit)) game->Player[1]->input(1); break;
        case Qt::Key_S: if((game->Player[1])&&(opts.bSplit)) game->Player[1]->input(2); break;
        case Qt::Key_A: if((game->Player[1])&&(opts.bSplit)) game->Player[1]->input(3); break;
        case Qt::Key_D: if((game->Player[1])&&(opts.bSplit)) game->Player[1]->input(4); break;

    }
}

void OpenGLWidget::calledByTimer()
{
    if(game->bGetScore)
    {
        timer->stop();
        SScoreData scr[2];
        game->getScore(scr);
        scored(scr);
    }
    else
    {
        game->calculate();
        updateGL();
    }
}
