#ifndef OPENGLWIDGET_H
#define OPENGLWIDGET_H

#include <QWidget>
#include <QGLWidget>
#include <QtGui>
#include <QtOpenGL>
#include <QTimer>
#include "cgame.h"

class OpenGLWidget : public QGLWidget
{
    Q_OBJECT

public:
    OpenGLWidget(SOptions *opt, QWidget *parent = 0);
    ~OpenGLWidget();
    CGame *game;

protected:
    void paintGL();
    void keyPressEvent(QKeyEvent *);

private:
    QTimer *timer;
    SOptions opts;

private slots:
    void calledByTimer();

signals:
    void cancel();
    void scored(SScoreData *);
};

#endif // OPENGLWIDGET_H
