#include "splitscore.h"
#include "ui_splitscore.h"

splitScore::splitScore(SScoreData *s, QWidget *parent) :
    QWidget(parent),
    m_ui(new Ui::splitScore),
    scr(s)
{
    m_ui->setupUi(this);
    if (scr[0].iScore >= scr[1].iScore) winner = 0;
    else winner = 1;
    fillTable();
    connect(m_ui->ok,SIGNAL(clicked()),this,SLOT(goOn()));
}

splitScore::~splitScore()
{
    delete m_ui;
}

void splitScore::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void splitScore::fillTable()
{
    m_ui->table->setColumnWidth(0,200);
    m_ui->table->setColumnWidth(1,100);
    m_ui->table->setColumnWidth(2,100);
    if (winner == 0)
    {
        for (int i=0;i<2;++i)
        {
            m_ui->table->setItem(i,1,new QTableWidgetItem(QString::number(scr[i].iScore)));
            m_ui->table->setItem(i,2,new QTableWidgetItem(QString::number(scr[i].iCollected)));
        }
        m_ui->table->setItem(0,0,new QTableWidgetItem(tr("Player 1 (Arrowkeys)")));
        m_ui->table->setItem(1,0,new QTableWidgetItem(tr("Player 2 (w,a,s,d)")));
    }
    else
    {
        for (int i=0;i<2;++i)
        {
            m_ui->table->setItem(1-i,1,new QTableWidgetItem(QString::number(scr[i].iScore)));
            m_ui->table->setItem(1-i,2,new QTableWidgetItem(QString::number(scr[i].iCollected)));
        }
        m_ui->table->setItem(1,0,new QTableWidgetItem(tr("Player 1 (Arrowkeys)")));
        m_ui->table->setItem(0,0,new QTableWidgetItem(tr("Player 2 (w,a,s,d)")));
    }
}

void splitScore::goOn()
{
    enterScore(scr[winner]);
}
